package com.sv.service.oms;

import com.github.pagehelper.PageHelper;
import com.sv.entity.VenueType;
import com.sv.mapper.VenueTypeMapper;
import com.ydd.framework.core.common.Pagination;
import com.ydd.framework.core.entity.enums.StatusEnum;
import com.ydd.framework.core.service.impl.BaseServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * Service - 场馆类型
 *
 * @author zuojie.Liang
 * @since 2018-08-02
 */
@Service
@Transactional(readOnly = true)
public class VenueTypeService extends BaseServiceImpl {

	private final Logger logger = LoggerFactory.getLogger(VenueTypeService.class);

	@Resource
	private VenueTypeMapper venueTypeMapper;

	/**
	 * 创建场馆类型
	 *
	 * @param venueType 场馆类型
	 */
	@Transactional
    public void save(VenueType venueType) {
		if (venueType.getId() != null && venueType.getId() > 0) {
			// 更新
			venueTypeMapper.update(venueType);
		} else {
			// 新建
			venueTypeMapper.insert(venueType);
		}
	}

	/**
	 * 更新场馆类型
 	 *
	 * @param venueType 场馆类型
	 */
	@Transactional
    public void update(VenueType venueType) {
		venueTypeMapper.update(venueType);
	}

	/**
	 * 删除场馆类型
	 *
	 * @param id 编号
   	 * @return 删除数量
	 */
	@Transactional
    public Integer delete(Integer id) {
		if (id == null || id <= 0) {
			return 0;
		}
		return venueTypeMapper.delete(id);
	}

	/**
	 * 删除场馆类型
	 *
	 * @param ids 编号数组
	 * @return 删除数量
	 */
	@Transactional
    public Integer deleteByIds(Integer[] ids) {
		if (ids == null || ids.length == 0) {
			return 0;
		}
		return venueTypeMapper.deleteByIds(ids);
	}

	/**
	 * 查询场馆类型
	 *
	 * @param id 编号
	 * @return 场馆类型
	 */
	public VenueType findById(Integer id) {
		return venueTypeMapper.findById(id);
	}

	/**
	 * 查询场馆类型
	 *
	 * @param pagination 分页信息
	 * @return 分页结果
	 */
	public Pagination findPage(Pagination pagination) {
		PageHelper.startPage(pagination.getPage(), pagination.getPageSize());
		PageHelper.orderBy("id desc");
		pagination.setQueryResult(venueTypeMapper.findAll());
		return pagination;
	}

	/**
	 * 更新状态
	 *
	 * @param ids 编号
	 * @param status 状态
	 * @return 更新数量
	 */
	@Transactional
	public Integer updateStatus(Integer[] ids, Byte status) {
		if (ids == null) {
			return 0;
		}
		if (status == null) {
			status = StatusEnum.DISABLE.value;
		}

		return venueTypeMapper.updateStatus(ids, status);
	}

	public List<VenueType> findTypeAll() {
		return venueTypeMapper.findAll();
	}

}

